      Program Digitize
c
      character*1 inchar
c
      character text*80, units*1/'f'/, terminal*6/'T4107'/
      real      x(2), y(2), level1/2000.0/, level
      integer   ichar, icol/2/, white, yellow, blue, green
      logical   new
c
      call tin('Is this a T4107, or MRTX80 ?',terminal)
      call shiftup(terminal)
      if(terminal.eq.'T4107') then 
        call groute('sel lt4107;e')
        white  = 49
        blue   = 50
        green  = 51
        yellow = 90
       else
        call groute('sel mrtx80;e')
        white  = 10
        blue   = 13
        green  = 11                                                       
        yellow = 14
      end if
      call gopen
      call gcursl(2)
      call gdiags(1,34,80,35)
c
c BEGIN TABLET COORDINATE SET UP
c
      call nin('Turn on tablet and tape your plot to tablet.')
      call nin('Digitize UTM origin by pressing any mouse key ')
10    CONTINUE
        call gwicol(2.0,3)
        call gcursr(xb1,yb1)
        call gdot(xb1,yb1,1)
        call rin('Give the x coordinate of this point',d1)
        call rin('Give the y coordinate of this point',t1)
        call nin('Now digitize a second point with the SAME '//
     >           'y coord. as point 1:')
        call gcursr(xb2,yb2)
        call gdot(xb2,yb2,1)
        call rin('Give the UTM X coordinate of this point',d2)
        call nin('Now digitize a third point with the SAME '//
     >           'x coord. as point 1:')
        call gcursr(xb3,yb3)
        call gdot(xb3,yb3,1)
        call gempty
        call rin('Give the UTM Y coordinate of this point',t2)
c
c              do some geometry 
c
        dyb1=yb2-yb1
        dxb1=xb2-xb1
        dyb2=yb3-yb1
        dxb2=xb3-xb1
        dist1=sqrt(dyb1*dyb1+dxb1*dxb1) ! length of distance axis
        dist2=sqrt(dyb2*dyb2+dxb2*dxb2) ! length of time axis
        tscale=abs(t2-t1)/dist2         ! scale of time axis
        dscale=abs(d2-d1)/dist1         ! scale of distance axis
        r180=4.*atan(1.e0)              ! pi
        theta=atan2(dyb1,dxb1)          ! rotation of distance axis on 
c                                                tablet
        if(d1.gt.d2)theta=theta+r180
        if(theta.gt.2*r180)theta=theta-2*r180
        dotp=dxb1*dxb2+dyb1*dyb2        ! dot product of axes
        phi=acos(dotp/(dist1*dist2))     ! angle betweeen axes
c
c          must check to see if coordinates are left or right handed
c
        theta2=atan2(dyb2,dxb2)-r180/2.
        if(t1.gt.t2)theta2=theta2+r180
        if(theta2.gt.2.*r180)theta2=theta2-2.*r180
        if(theta.lt.0)theta=theta+2.*r180
        if(theta2.lt.0)theta2=theta2+2.*r180
        dd2=theta2-theta
        rtendeg=r180/18.
        r350=r180*1.9
        if(abs(dd2).gt.rtendeg.and.abs(dd2).lt.r350) tscale=-tscale
c
        ct=cos(theta)
        st=sin(theta)
        xbo=xb1-d1*ct/dscale+t1*st/tscale ! origin of plot in tab coords
        ybo=yb1-d1*st/dscale-t1*ct/tscale ! origin of plot in tab 
        degtheta=theta*180./r180
        degphi=phi*180./r180
c
c              end geometry
c
        write(text,'(a,f8.3,a,f8.3,a)')
     >  ' Distance scales are ',dscale,' and ', tscale, ' units/inch.'
        call nin(text)
        text=' '
        write(*,'(a,f8.3,a)')
     &  ' The plot is rotated by ',degtheta,' degrees on the tablet.'
        write(*,'(a,f8.3,a)')
     &  ' The angle between the axes is ',degphi,' degrees.'
        degtheta2=theta2*180./r180
        if(tscale.lt.0)then
          write(*,*)'Your axis system is left handed r2=',degtheta2
        else
          write(*,*)'Your axis system is right handed r2=',degtheta2
        end if
        inchar = 'n'
        call tin('Redo the coordinate system ? (y/n)',inchar)
        if(inchar.eq.'y'.or.inchar.eq.'Y')go to 10
c
c   END OF TABLET SET UP
c
      text = 'digit.dat'
210   call tin('Give output file for digitized data',text)
      open(1,file=text,err=210,status='new',carriagecontrol='list')
      text = ' '
      call tin('Give title line for this file : ',text)
      write(1,'(a)') text
      call tin('Contour levels in m_eters or f_eet ?', units)
      write(1,*) d1, t1, '    All distances in meters'    !UTM coordinates
1000  call rin('Contour level (BLUE=new level, YELLOW=quit) ?', 
     >         level1)
      if(units.eq.'f'.or.units.eq.'F') level = level1*12.0*0.0254
c
c BEGIN MAIN PICKING LOOP
c                                                             
      new = .true.
300   call gcursr(xb,yb)
      call gcurky(ichar)
      call gdiagc('BELL')
c
      if (ichar.eq.yellow)then         ! finish session
        inchar = 'n'
        call tin('Are you sure you want to quit ?',inchar)
        if(inchar.eq.'y'.or.inchar.eq.'Y') then 
          call gclose
          close(unit=1)
          stop
         else
          goto 300
        end if
       else if(ichar.eq.white) then 
        call tab_to_g(xb,yb,dscale,tscale,st,ct,xbo,ybo,d,t)
        write(1,*) d, t, level
       else if(ichar.eq.green) then 
        call tab_to_g(xb,yb,dscale,tscale,st,ct,xbo,ybo,d,t)
        write(1,*) d, t, level
       else if(ichar.eq.blue)then
        call iin('Color for next contour (1-9) ',icol)
        goto 1000
      end if
      if(new) then
        x(1) = xb
        y(1) = yb
        new = .false.
      end if
      x(2) = xb
      y(2) = yb
      call gwicol(-1.0,icol)
      call gvect(x,y,2)
      x(1) = xb
      y(1) = yb
      go to 300
      end
c-----------------------------------------------------------------------------
      function clength(text,nmax)
c-----------------------------------------------------------------------------
c find the length of string
c
      character*1 text(nmax)
      do k=nmax,1,-1
         clength=k
         if(text(k).ne.' ')return
      end do
      clength=0
      return
      end
            
c-----------------------------------------------------------------------------
      subroutine g_to_tab(d,t,dscale,tscale,st,ct,xbo,ybo,xb,yb)
c-----------------------------------------------------------------------------
c return xb,yb the tablet coordinates given graph coordinates.
c
      xb=d*ct/dscale-t*st/tscale+xbo
      yb=d*st/dscale+t*ct/tscale+ybo
      return
      end
c-----------------------------------------------------------------------------
      subroutine tab_to_g(xb,yb,dscale,tscale,st,ct,xbo,ybo,d,t)
c-----------------------------------------------------------------------------
c return d,t, the graph coordinates given table coordinates
c
      d=dscale*((xb-xbo)*ct+(yb-ybo)*st)
      t=tscale*(-(xb-xbo)*st+(yb-ybo)*ct)
      return
      end

